#include <bits/stdc++.h>

using namespace std;
// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx2,bmi,sse,sse2")
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp/>
#include <utility>
// using namespace __gnu_pbds;
// template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
// mt19937_64 rng();
#define int long long

int maxn = 1001, inf = 3e18, modd = 1e9 + 7, k = 127;

struct segtree {
    int n;
    vector<int> tree;

    explicit segtree(vector<int> &a) {
        n = a.size();
        tree.assign(4 * n, 0);
        build(0,0,n,a);
    }

    void build(int v,int l, int r, vector<int> &a) {
        if (r - l == 1) {
            tree[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }

    int get(int ql, int qr, int v,int l, int r) {
        if (l >= qr || r <= ql) {
            return 0;
        }
        if (l >= ql && r <= qr) {
            return tree[v];
        }
        int mid = (l + r) / 2;
        return max(get(ql, qr, 2 * v + 1, l, mid), get(ql, qr, 2 * v + 2, mid, r));
    }

    int get(int ql, int qr) {
        return get(ql, qr, 0,0,n);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> h(n);
    for (int& i : h) cin >> i;
    vector<int> kk(n - 1);
    for (int& i : kk) cin >> i;
    // if (count(kk.begin(), kk.end(), 1) == n - 1) {
    //
    //     return;
    // }

    segtree seg(h);
    deque<deque<int>> bl(n);
    for (int i = 0; i < n; i++) {
        bl[i] = {h[i]};
    }
    for (int i = 0; i < n - 1; i++) {
        int k = kk[i];
        int l = 0, r = 0;
        int cnt = 0;
        int j = 0;
        int last = 0, frst = 0;
        while (cnt != k) {
            cnt += !(bl[j].empty());
            l += bl[j].size();
            frst = j;
            j++;
        }
        r = l;
        l -= bl[frst].size();
        while (true) {
            r += bl[j].size();
            last = j;
            if (!bl[j].empty()) break;
            j++;
        }
        for (int q : bl[last]) {
            bl[frst].push_back(q);
        }
        bl[last].clear();
        int res = 0;
        for (int q = l; q < r; q++) {
            int d = min(seg.get(l, q + 1), seg.get(q, r)) - h[q];
            res += d;
        }
        cout << res << endl;
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    // cout.tie(0);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
