#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi2,sse2")
using namespace std;
#define int long long

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
#define nat(x) abs((int)rng()) % x;

const int inf = 1e18;

//int n, int k, vector<int> a

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n + 2);
    vector<int> ps(n + 2), pm(n + 2, inf), sm(n + 2, inf);
    for (int i = 1; i <=n; i++) {
        cin >> a[i];
        ps[i] = ps[i - 1] + a[i];
        pm[i] = min(pm[i - 1], a[i]);
    }
    for (int i = n; i >= 1; i--) {
        sm[i] = min(sm[i + 1], a[i]);
    }
    k = n - k + 1;
    int res = -inf;
    for (int i = k; i <= n; i++) {
        int r1 = (ps[i] - ps[i - k]) - min(pm[i - k], sm[i + 1]);
        res = max(res, r1);
    }
    cout << res << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    // cout.tie(nullptr);
    int T = 1;
    while (T--) {
        // int n = 10;
        // int k = nat(8) + 2;
        // // int k = 6;
        // k = max(k, 2ll);
        // vector<int> z(n + 2);
        // cout << n << ' ' << k << endl;
        // for (int i = 1; i <= n; i++) {
        //     z[i] = nat(10);
        //     cout << z[i] << ' ';
        // }
        // // z = {1,4,3,7,8,7,7,9,4,2};
        // cout << endl;
        // solve(n, k, z);
        // cout << endl;
        solve();
    }
    return 0;
}
