#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi2,sse2")
using namespace std;
#define int long long

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
#define nat(x) abs((int)rng()) % x;

const int inf = 1e18;

void solve() {
    int n, s;
    cin >> n >> s;
    vector<unordered_map<int, int> > ww(n + 1);
    vector<vector<int> > dp(n + 1, vector<int>(s + 1));
    vector<vector<pair<int, int> > > pr(n + 1, vector<pair<int, int> >(s + 1));
    vector<vector<int> > w(n + 1);
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        w[i].assign(k, 0);
        for (int j = 0; j < k; j++) {
            cin >> w[i][j];
            ww[i][w[i][j]] = j;
        }
    }
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < w[i].size(); j++) {
            vector<bool> f(s + 1);
            for (int k = 0; k <= s; k++) {
                if (k - w[i][j] >= 0) {
                    if (!dp[i][k]) {
                        if (dp[i - 1][k - w[i][j]]) {
                            dp[i][k] = 1;
                            f[k] = true;
                            pr[i][k] = {j, 1};
                        }
                    }
                    if (!dp[i][k]) {
                        if (dp[i][k - w[i][j]] && !f[k - w[i][j]]) {
                            dp[i][k] = 1;
                            f[k] = true;
                            pr[i][k] = {j, 0};
                        }
                    }
                }
            }
        }
    }
    // for (int i = 1; i <= s; i++) {
    //     if (dp[n][i]) {
    //         cout << i << ' ';
    //     }
    // }
    // return;
    if (dp[n][s]) {
        cout << "Yes" << endl;
        vector<vector<int> > res(n + 1);
        int ii = n, jj = s;
        while (ii != 0 && jj != 0) {
            res[ii].push_back(pr[ii][jj].first);
            auto x = pr[ii][jj];
            jj -= w[ii][x.first];
            ii -= x.second;
        }
        for (int i = 1; i <= n; i++) {
            sort(res[i].begin(), res[i].end());
            cout << res[i].size() << endl;
            for (int j: res[i]) {
                cout << j + 1 << ' ';
            }
            cout << endl;
        }
        return;
    }
    cout << "No" << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    while (T--) {
        solve();
    }
    return 0;
}
